Add favourite launchers on first run

Bug #622146 reported by Mark Shuttleworth on 2010-08-22
10
This bug affects 2 people
Affects Status Importance Assigned to Milestone
BAMF
Medium
Jason Smith
Unity
Fix Released
Medium
Jason Smith
bamf (Ubuntu)
Medium
Jason Smith
unity (Ubuntu)
Medium
Jason Smith

Bug Description

Many users will try unity, coming from the desktop or previous UNR. We should make an effort, on first run, to identify their favourite applications and put them in the Unity launcher.

MPT would have a more complete understanding of the options, feel free to update the bug description, but as a start I'd suggest:

 - gnome panel launchers other than those we put there by default,
 - desktop launchers
 - kde start menu favourites?

Any first run code should be isolated and not break unity if it fails for any reason! i.e. test error conditions and handling and design for robustness!

Changed in unity:
importance: Undecided → Medium
David Barth (dbarth) on 2010-09-02
Changed in unity:
assignee: nobody → Didier Roche (didrocks)
milestone: none → 2010-09-09
status: New → Triaged
Changed in ubuntu:
status: New → Incomplete
importance: Undecided → Medium
status: Incomplete → Triaged
affects: ubuntu → unity (Ubuntu)
Changed in unity (Ubuntu):
assignee: nobody → Didier Roche (didrocks)
milestone: none → ubuntu-10.10

It should look in Netbook launcher favorites as well, and do this at first run *only*.

Sebastien Bacher (seb128) wrote :

Do you want to collect all of those? Or just have a prefered environment order and import the ones from there? It seems wrong to import GNOME, UNE and KDE launchers...

Good point!

I don't think we should introspect KDE as well, as anyone who is
maintaining both GNOME and KDE desktops probably keeps those worlds
separate. If someone has a KDE app on their GNOME panel, however, we
should map that in.

With regard to UNE and GNOME desktops, I'd say pull both sets in to the
Unity launcher, once only.

Mark

Didier Roche (didrocks) wrote :

Ok, I'll try to work on that when I have a couple of hours available.

From what I can see, we can get an issue with personal launchers created by user, which means:
1. Right click on the panel "add to panel", "create a launcher" and filling an app name/icon/command line
1. (bis) right click on the desktop -> "create a launcher" and filling an app name/icon/command line
-> this create an icon either on ~/.gnome2/panel2.d/default/launchers/ or on ~/<Desktop> (<Desktop being translated)

(this isn't the case if we drag and drop a launcher on the panel from the Applications menu, the original desktop file in /usr/share/applications is still in use)

2. if we transition that to the unity panel, the icon will appear.
3. if we click on it, bamf will try to match the application to a destkop file in /usr/share/applications/, and so, we will have two launchers from the same app appearing and not the good match.

What to do in that case? In addition to that, all user launchers aren't in /usr/share/applications/ and so, those not having a desktop file there won't be match as well (there will only be transitionned icon in the panel, but not match on running)

I see three ways of doing that:
1. add some magic to bamf to get that case right (and discover from which .desktop file the application has been called).
This will be the best fix, not sure about the timeline of it. It will enable also in the feature for people adding launchers manually and having a good match.
-> Just tested with latest bamf, and can confirm it's not working as of today (rename and copy a gconf key like firefox.desktop to ~/Desktop, clicking on it after restarting unity -> a new firefox launcher appears and is matched, not the manual one).

2. Check on personal .desktop file which command-line is set, making a dpkg -L to get if there is a .desktop file from the same package launching the same command line and setting the new launcher to that path. This is more work on the first launch, and won't transition launchers which don't match exactly from the command line (they won't appear in unity). But can transition more options than 3.

3. Only transition desktop file resulting from a drag and drop from the Applications menu: this will only work from those in the panel, not on the Desktop. And won't work for people creating launchers with right click.

I see no issue with launchers in current lucid netbook-launcher has the limitation was the same than current unity (can't add favorites which don't have a .desktop file in /usr/share/applications)

I'm waiting for some inputs about which strategy seems to be the best.

Mark Shuttleworth (sabdfl) wrote :

How do we match icons etc for things launched at the command line? Could
we use the same approach for things manually added to a gnome-panel
config? And if it resolves to the same .desktop file, we don't need to
add a new launcher?

Didier - unfortunately, I think the right-click method is very common.
If we have a big database of contributed gconf settings, we could
analyse *how* common :)

Mark

Didier Roche (didrocks) wrote :

Le vendredi 03 septembre 2010 à 14:17 +0100, Mark Shuttleworth a écrit :
> How do we match icons etc for things launched at the command line? Could
> we use the same approach for things manually added to a gnome-panel
> config? And if it resolves to the same .desktop file, we don't need to
> add a new launcher?

Hum, I think the match is done on *running* apps by bamf, not on the
command line itself. And I think running each app for the transition
phase, getting the match in one way, and closing them is not an
option. :)

Let me ping Jason on that so that I can get feedback there.

> Didier - unfortunately, I think the right-click method is very common.
> If we have a big database of contributed gconf settings, we could
> analyse *how* common :)

Yeah, I more than agree :) Just listing the possible solutions, even bad
ones :)

Didier Roche (didrocks) wrote :

Le vendredi 03 septembre 2010 à 14:17 +0100, Mark Shuttleworth a écrit :
> How do we match icons etc for things launched at the command line? Could
> we use the same approach for things manually added to a gnome-panel
> config? And if it resolves to the same .desktop file, we don't need to
> add a new launcher?

Hum, I think the match is done on *running* apps by bamf, not on the
command line itself. And I think running each app for the transition
phase, getting the match in one way, and closing them is not an
option. :)

Let me ping Jason on that so that I can get feedback there.

> Didier - unfortunately, I think the right-click method is very common.
> If we have a big database of contributed gconf settings, we could
> analyse *how* common :)

Yeah, I more than agree :) Just listing the possible solutions, even bad
ones :)

Jason Smith (jassmith) wrote :

Confirming I know about this and intend to add API (bamf_matcher_register_favorites) to make this possible.

Didier Roche (didrocks) wrote :

Ok, added bamf task for that. Thanks Jason!

Changed in bamf:
status: New → Triaged
importance: Undecided → Medium
assignee: nobody → Jason Smith (jassmith)
Changed in bamf (Ubuntu):
assignee: nobody → Jason Smith (jassmith)
milestone: none → ubuntu-10.10
status: New → Triaged
importance: Undecided → Medium
Didier Roche (didrocks) on 2010-09-08
Changed in unity:
status: Triaged → Fix Committed
Didier Roche (didrocks) wrote :

let the unity opened, I think that Jason still have a patch to rollout for finishing the matching.
The migration script is now launched the first time your run unity.

Changed in unity (Ubuntu):
status: Triaged → Fix Released
status: Fix Released → Triaged
Changed in bamf (Ubuntu):
status: Triaged → Fix Released
Changed in unity:
status: Fix Committed → Triaged
Changed in bamf:
status: Triaged → Fix Released
Changed in unity:
assignee: Didier Roche (didrocks) → Jason Smith (jassmith)
Changed in unity (Ubuntu):
assignee: Didier Roche (didrocks) → Jason Smith (jassmith)
Changed in unity:
milestone: 2010-09-09 → 2010-09-16
Mark Shuttleworth (sabdfl) wrote :

Thanks Didrocks, this was very fast, cool work!

Neil J. Patel (njpatel) on 2010-09-16
Changed in unity:
milestone: 2010-09-16 → 2010-09-22
Didier Roche (didrocks) wrote :

just a follow up with unity 0.2.40:

- everything works fine, except than:
1. add a custom launcher (with custom icon, like mahjong, opening totem)
2. at start, you will see the majhong's icon
3. clicking on it, it will launch totem
BUT here:
- the icon changes to totem
- there is no match to this icon of the launcher

(that's still what needed to be fixed in unity for this bug report to be closed)

David Barth (dbarth) wrote :

Which i will summarize as:
- in maverick, custom icons in custom launchers are not supported, we default to the canonical theme icon for the application
- but there is still a bug with custom launcher/apps status not being correctly reflected in the launcher (missing active state triangle)

Jason Smith (jassmith) on 2010-09-22
Changed in unity:
status: Triaged → Fix Committed
Didier Roche (didrocks) on 2010-09-22
Changed in bamf (Ubuntu):
status: Fix Released → Fix Committed
Launchpad Janitor (janitor) wrote :
Download full text (3.7 KiB)

This bug was fixed in the package unity - 0.2.42-0ubuntu1

---------------
unity (0.2.42-0ubuntu1) maverick; urgency=low

  * New upstream release:
    - "Applications" and "Files & Folders" tooltips are not translatable
      (LP: #644215)
    - Fix inactive menus are accessible on switching to a window (LP: #604505)
    - Fix wrong launcher tile label/quicklist x position (LP: #631446)
    - Fix highlighted items in quicklist have different widths (LP: #643315)
    - In migration tool, being safe when people are using crazy caracters in
      desktop file (LP: #644114, #635156)
    - Detect if 3D acceleration support is provided. Otherwise, prompt for
      logout and change default session (LP: #614088)
    - Fix quicklist shows hidden menu items (LP: #641543)
    - Fix removing launchers via dnd fails (LP: #643434)
    - Better launcher auto-scroll performances (LP: #640560)
    - Make the insensitive state of the forward- and back-button more obvious by
      decreasing their opacity, thus users don't assume they are actually
      clickable. (LP: #638285)
    - Fix some dialogs aren't maximized but are undecorated (LP: #628822)
    - Fix some menus don't go away when window closes (LP: #640557)
    - Fixes bug where the wrong icon where at times associated with a tile in
      the places view. (LP: #642935)
    - Speedup icon loading (LP: #641246)
    - Make trash menu items in Unity are either not translatable or translations
      are not loaded (LP: #645038)
    - Fix using dnd on launcher makes focus not work out of the unity ui
      (LP: #637123)
    - Multi-monitor support (LP: #637123)
    - Enable/disable super key by a gconf key (LP: #632581)
    - Remove glow on fold (LP: #619344)
    - Ensure we dont map windows when expose is active (LP: #599766)
    - take new indicator API for action for top-level dropdown menu item not
      activated (LP: #637692)
    - Make the home buttons reactive (LP: #638857)
    - Add red tint when search fails (LP: #607821)
    - New (and final!) UI adjustement, but UNE isn't in the doc as seen with
      the doc team (LP: #627009)
    - Single-touches on the launcher are usually interpreted as a drag
      (LP: #641328)
    - URI activation in global view (LP: #612562)
    - Clicking a Place icon while viewing the same place in the Dash should
      return to the Home screen of that place and clear the search (LP: #607829)
    - Fix mutter crashed with SIGSEGV in g_type_check_instance() (LP: #641561)
    - Fix panel and menu item font colors don't match (LP: #637480)
    - Fix indicators have orange color (LP: #632975)
    - Fix inactive menus are accessible on switching to a window (LP: #604505)
    - Use semi-transparent rectangle around launcher-icon (LP: #643388)
    - Fix mutter crashes when closing pop-up dialog (LP: #642669)
    - Change launcher icon reference size loading (LP: #641669)
    - Fix mutter crashing in mumble start (LP: #641335)
    - Fix clicking on a category from CoFs does not directly take you to the
      desired category (LP: #638402)
    - Fix some menus don't go away when window closes (LP: #640557)
    - Launchers should act like if the application was not focussed ...

Read more...

Changed in unity (Ubuntu):
status: Triaged → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package bamf - 0.2.54-0ubuntu1

---------------
bamf (0.2.54-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * cherry pick some patches from upstream too for more fixes in special
    launchers (LP: #622146)
  * debian/libbamf0.symbols:
    - update to latest version
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 19:21:45 +0200

Changed in bamf (Ubuntu):
status: Fix Committed → Fix Released
Neil J. Patel (njpatel) on 2010-12-01
Changed in unity:
status: Fix Committed → Fix Released
Adolfo Jayme (fitojb) on 2014-01-11
no longer affects: bamf (Ubuntu Quantal)
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers